<script lang="ts" setup>
import { nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import type { Product } from '@/types/Product'
import http from '@/services/http'
import { useLoadingStore } from '@/stores/loading'
import productService from '@/services/Product'
import { useProductStore } from '@/stores/product'
import { useTypeStore } from '@/stores/type'
const productStore = useProductStore()
const headers = [
  {
    title: 'Id',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Photo',
    key: 'image'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },

  {
    title: 'Price',
    key: 'price',
    value: 'price'
  },
  {
    title: 'Type',
    key: 'type',
    value: (item: any | Product) => item.type.name
  },
  { title: 'Actions', key: 'actions', sortable: false }
]
const typeStore = useTypeStore()

const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const type = ref()

function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    productStore.clearForm()
  })
}
async function deleteItemConfirm() {
  // Delete item from list
  await productStore.deleteProduct()
  closeDelete()
}
async function editItem(item: Product) {
  if (!item.id) return
  await productStore.getProduct(item.id)
  dialog.value = true
}
async function deleteItem(item: Product) {
  if (!item.id) return
  await productStore.getProduct(item.id)
  dialogDelete.value = true
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    productStore.clearForm()
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await productStore.saveProduct()
  closeDialog()
}

onMounted(async () => {
  await productStore.getProducts()
  await typeStore.getTypes()
})
</script>
<template>
  <div>
    <v-data-table :headers="headers" :items="productStore.products">
      <template v-slot:top>
        <v-toolbar flat>
          <v-toolbar-title>Products</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <!-- Put Edited Dialog -->

          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn color="primary" v-bind="props"> New Product </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Product Profile</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="productStore.editedProduct.name"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Name"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model.number="productStore.editedProduct.price"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Price"
                        ></v-text-field>
                      </v-col>

                      <v-col cols="12" sm="6">
                        <v-combobox
                          v-model="productStore.editedProduct.type"
                          :items="typeStore.types"
                          item-title="type"
                          item-value="type"
                          label="Select type"
                          :return-object="true"
                        ></v-combobox>
                      </v-col>

                      <v-col cols="12" sm="12" md="4">
                        <v-file-input
                          v-model="productStore.editedProduct.files"
                          :rules="[
                            (value) => {
                              return (
                                !value ||
                                !value.length ||
                                value[0].size < 2000000 ||
                                'Image size should be less than 2 MB!'
                              )
                            }
                          ]"
                          accept="image/png, image/jpeg"
                          label="Avatar"
                          placeholder="Pick an Image"
                          prepend-icon="mdi-camera"
                        ></v-file-input>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-img
                          :src="
                            'http://localhost:3000/images/products/' +
                            productStore.editedProduct.image
                          "
                        ></v-img>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <!-- Delete Dialog-->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5"
                >Are you sure you want to delete this item?</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
        <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
      <template v-slot:[`item.image`]="{ item }">
        <v-img :src="'http://localhost:3000/images/products/' + item.image" width="100"></v-img>
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="productStore.getProducts"> Reset </v-btn>
      </template>
    </v-data-table>
  </div>
</template>
